/*
Антон (Лилой) Москаленко
e-mail: liloi@mail.ru
07/05/06

[dekart].x - x-координата в декартовой системе
[dekart].y - y-координата в декартовой системе

[polar].ro - модуль вектора (Ро) в полярной системе
[polar].fi - угол, на который вектор (Ро) повернулся

dek_to_pol(...) и pol_to_dek(...) - функции преобразования декартовой в полярную
и наоборот. Ф. dek_to_pol следует употреблять с осторожностью (x должно быть не
равно 0, иногда, хотя и очень редко, "выносит" неправильные значения. Все связано
с тем, с какой точностью компилятор вычисляет. А тат как я сравниваю значения
(arctg(x) выдает 2 значения) то тут (иногда) выпадает нестыковка. Если знаете
как исправить - пишите мне.

range_pol(...) - растояние между точками в полярной системе.

add_angle(...) - добавить угол к точке. Вы скажете: почему нелзя так:

    polar a;
    a.ro = 3;
    a.fi = M_PI;

    a.fi += M_PI/2;

Отвечаю: можно :-) Но функция проверяет: если модуль угла больше за Пи, то она прибавляет
(или отнимает) Пи. И так продолжается до тех пор, пока выполнается даное условие.

*/

#ifndef L_POLAR
#define L_POLAR

#include <math.h>

struct polar
{
    double ro;
    double fi;
};

struct dekart
{
    double x;
    double y;
};


dekart pol_to_dek(polar a);


polar add_angle(polar a, double ang)
{
    a.fi += ang;
    re:if(fabs(a.fi)>(2*M_PI))
    {
        if(a.fi>=0)a.fi -= 2*M_PI; else a.fi += 2*M_PI;
        goto re;
    }
    return a;
}


double range_pol(polar a, polar b)
{
    
    dekart aa = pol_to_dek(a);
    dekart bb = pol_to_dek(b);
    
    dekart c;
    c.x = fabs(aa.x-bb.x);
    c.y = fabs(aa.y-bb.y);
    
    double ret = pow(pow(c.x,2)+pow(c.y,2),0.5);
    return ret;
}


dekart pol_to_dek(polar a)
{
    dekart ret;
    ret.x = a.ro*cos(a.fi);
    ret.y = a.ro*sin(a.fi);
    return ret;
}


dekart pol_to_dek(double ro, double fi)
{
    dekart ret;
    ret.x = ro*cos(fi);
    ret.y = ro*sin(fi);
    return ret;
}


polar dek_to_pol(dekart a) // !!!
{
    polar ret;
    ret.ro = pow((pow(a.x,2)+pow(a.y,2)),0.5);

    double z = atan(a.y/a.x);
    
    if((pol_to_dek(ret.ro,z).x!=a.x)&&(pol_to_dek(ret.ro,z).y!=a.y))
        z += M_PI;
        
    ret.fi = z;
    
    return ret;
}


polar dek_to_pol(double x, double y) // !!!
{
    polar ret;
    ret.ro = pow((pow(x,2)+pow(y,2)),0.5);

    double z = atan(y/x);
    
    if((pol_to_dek(ret.ro,z).x!=x)&&(pol_to_dek(ret.ro,z).y!=y))
        z += M_PI;
    
    ret.fi = z;
    
    return ret;
}

#endif

//
